/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package model2muster;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

/**
 *
 * @author micha
 */
public class Controller extends HttpServlet {

    PrintWriter out;

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        out = response.getWriter();

        String action = request.getParameter("action");

        if (action == null) {
            action = "NULL";
        }

        //attribute mit application-scope verwalten
        ServletContext sc = this.getServletContext();
        sc.setAttribute("bla", "blablabla");

        Gigplan plan;
        plan = (Gigplan) sc.getAttribute("plan");
        if (plan == null) {
            plan = new Gigplan();
            sc.setAttribute("plan", new Gigplan());
        }

        //session holen
        HttpSession session = request.getSession();

        //attribut fuer sichtbarkeit einiger buttons in der view
        session.setAttribute("sichtbarkeit", new String("hidden"));

        //models im session-objekt ablegen
        Musiker musiker;
        musiker = (Musiker) session.getAttribute("musiker");

        if (musiker == null) {
            musiker = new Musiker(null, null, null);
            session.setAttribute("musiker", musiker);
        }

        String url = "/WEB-INF/view/formular.jsp";

        if (action.equals("REFRESH")) {

            url = "/WEB-INF/view/formular.jsp";
            musiker.setVname(request.getParameter("vorname"));
            musiker.setNname(request.getParameter("nachname"));
            musiker.setInstrument(request.getParameter("instrument"));
            session.setAttribute("sichtbarkeit", new String("visible"));

        } else if (action.equals("CONFIRM")) {
            Musiker m = (Musiker) session.getAttribute("musiker");
            plan.getBesetzung().add(m.getInstrument()+", "+m.getVname()+", "+m.getNname());
        }

        //ServletContext sc = getServletContext();
        RequestDispatcher rd = sc.getRequestDispatcher(url);
        rd.forward(request, response);
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

    //konstruktor
    public Controller() {
        // objekte mit application-scope werden in direkt im servletContext abgelegt:

    }

}
